<?php

namespace Teknisa\EST\Factories;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class FecharDia {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getInventestcego($params) {
        $sql = "SELECT I.CDFILIAL,
                       DTCONTAGEM,
                       IDSITESTCEGO,
                       IDOBREALACEDIV,
                       IDBLOQFECINVPE
                  FROM INVENTESTCEGO I,
                       PARAMFILIAL P
                 WHERE I.CDFILIAL    = :CDFILIAL
                   AND I.CDFILIAL    =  P.CDFILIAL
                   AND IDINVESTCEGO  = 'S'
                   AND IDSITESTCEGO IN ('PR','DG','ED', 'AP')
                   AND DTCONTAGEM BETWEEN :DTPROCESSA AND :PXDTPROCESSA";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getInventestcegoDivergenceParams($params) {
        $sql = "SELECT I.CDFILIAL,
                       I.DTCONTAGEM,
                       I.CDALMOXARIFE,
                       I.CDLOCALESTOQ,
                       I.IDSITESTCEGO,
                       I.IDSITUACEITEINV
                  FROM INVENTESTCEGO I,
                       PARAMFILIAL P
                 WHERE I.CDFILIAL      = :FILIPROC
                   AND DTCONTAGEM      = (SELECT MAX(DTCONTAGEM)
                                            FROM INVENTESTCEGO
                                           WHERE CDFILIAL   = :FILIPROC
                                             AND DTCONTAGEM < :DTPROC)
                   AND IDSITESTCEGO    = 'AP'
                   AND IDSITUACEITEINV = 'P'
                   AND I.CDFILIAL      =  P.CDFILIAL
                   AND IDINVESTCEGO    = 'S'
              ORDER BY DTCONTAGEM";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getInventestcegoDivergences($params) {
        $sql = "SELECT CDPRODUTO,
                       NMPRODUTO,
                       CDARVPROD,
                       SGUNIDADE,
                       CDFILIAL,
                       CDALMOXARIFE,
                       CDLOCALESTOQ,
                       DTCONTAGEM,
                       NRLOTEESTQ,
                       NRSUBLOTE,
                       IDGERITINVCEGPR,
                       QTINVENTESTCEGO,
                       IDAJUSTEGERAIT,
                       QTESTOQDIA
                 FROM (SELECT IT.CDPRODUTO,
                              NMPRODUTO,
                              CDARVPROD,
                              SGUNIDADE,
                              IT.CDFILIAL,
                              IT.CDALMOXARIFE,
                              IT.CDLOCALESTOQ,
                              IT.DTCONTAGEM,
                              IT.NRLOTEESTQ,
                              IT.NRSUBLOTE,
                              IT.IDGERITINVCEGPR,
                              QTINVENTESTCEGO,
                              IDAJUSTEGERAIT,
                             (SELECT SUM(QTESTOQDIA)
                                FROM POSESTDIA D
                              WHERE (D.CDFILIAL     = IT.CDFILIAL)
                                AND (D.CDALMOXARIFE = IT.CDALMOXARIFE)
                                AND (D.CDLOCALESTOQ = IT.CDLOCALESTOQ)
                                AND (D.NRLOTEESTQ   = IT.NRLOTEESTQ)
                                AND (D.NRSUBLOTE    = IT.NRSUBLOTE)
                                AND (D.CDPRODUTO    = IT.CDPRODUTO)
                                AND (DTPOSIESTQ     = (SELECT MAX(DTPOSIESTQ)
                                                         FROM POSESTDIA
                                                       WHERE (CDFILIAL     = D.CDFILIAL)
                                                         AND (CDALMOXARIFE = D.CDALMOXARIFE)
                                                         AND (CDLOCALESTOQ = D.CDLOCALESTOQ)
                                                         AND (CDPRODUTO    = D.CDPRODUTO)
                                                         AND (NRLOTEESTQ   = D.NRLOTEESTQ)
                                                         AND (NRSUBLOTE    = D.NRSUBLOTE)
                                                         AND (DTPOSIESTQ  <= :DTCONTAGEM + 1)))) AS QTESTOQDIA
                         FROM ITEMINVENTCEGO IT,
                              INVENTESTCEGO IC,
                              PRODUTO P
                        WHERE IT.CDFILIAL     = :CDFILIAL
                          AND IT.DTCONTAGEM   = :DTCONTAGEM
                          AND IT.CDALMOXARIFE =  IC.CDALMOXARIFE
                          AND IT.CDFILIAL     =  IC.CDFILIAL
                          AND IT.CDALMOXARIFE =  IC.CDALMOXARIFE
                          AND IT.CDLOCALESTOQ =  IC.CDLOCALESTOQ
                          AND IT.DTCONTAGEM   =  IC.DTCONTAGEM
                          AND IT.CDPRODUTO    =   P.CDPRODUTO
                          AND IC.IDSITESTCEGO = 'AP') I
                 WHERE QTINVENTESTCEGO <> QTESTOQDIA";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getInventestcegoPosestdia($params) {
        $sql = "SELECT CDPRODUTO,
                       NMPRODUTO,
                       CDARVPROD,
                       SGUNIDADE,
                       CDFILIAL,
                       CDALMOXARIFE,
                       CDLOCALESTOQ,
                       DTCONTAGEM,
                       NRLOTEESTQ,
                       NRSUBLOTE,
                       IDGERITINVCEGPR,
                       QTINVENTESTCEGO,
                       IDAJUSTEGERAIT,
                       QTESTOQDIA
                 FROM (SELECT IT.CDPRODUTO,
                              NMPRODUTO,
                              CDARVPROD,
                              SGUNIDADE,
                              IT.CDFILIAL,IT.CDALMOXARIFE,
                              IT.CDLOCALESTOQ,
                              IT.DTCONTAGEM,
                              IT.NRLOTEESTQ,
                              IT.NRSUBLOTE,
                              IT.IDGERITINVCEGPR,
                              QTINVENTESTCEGO,
                              IDAJUSTEGERAIT,
                             (SELECT SUM(QTESTOQDIA)
                                FROM POSESTDIA D
                              WHERE (D.CDFILIAL     = IT.CDFILIAL)
                                AND (D.CDALMOXARIFE = IT.CDALMOXARIFE)
                                AND (D.CDLOCALESTOQ = IT.CDLOCALESTOQ)
                                AND (D.NRLOTEESTQ   = IT.NRLOTEESTQ)
                                AND (D.NRSUBLOTE    = IT.NRSUBLOTE)
                                AND (D.CDPRODUTO    = IT.CDPRODUTO)
                                AND (DTPOSIESTQ     = (SELECT MAX(DTPOSIESTQ)
                                                         FROM POSESTDIA
                                                       WHERE (CDFILIAL     =  D.CDFILIAL)
                                                         AND (CDALMOXARIFE =  D.CDALMOXARIFE)
                                                         AND (CDLOCALESTOQ =  D.CDLOCALESTOQ)
                                                         AND (CDPRODUTO    =  D.CDPRODUTO)
                                                         AND (NRLOTEESTQ   =  D.NRLOTEESTQ)
                                                         AND (NRSUBLOTE    =  D.NRSUBLOTE)
                                                         AND (DTPOSIESTQ  <= TO_DATE(:DTCONTAGEM,'DD/MM/YYYY') + 1)))) AS QTESTOQDIA
                         FROM ITEMINVENTCEGO IT,
                              INVENTESTCEGO IC,
                              PRODUTO P
                        WHERE IT.CDFILIAL     = :CDFILIAL
                          AND IT.DTCONTAGEM   = :DTCONTAGEM
                          AND IT.CDALMOXARIFE =  IC.CDALMOXARIFE
                          AND IT.CDFILIAL     =  IC.CDFILIAL
                          AND IT.CDALMOXARIFE =  IC.CDALMOXARIFE
                          AND IT.CDLOCALESTOQ =  IC.CDLOCALESTOQ
                          AND IT.DTCONTAGEM   =  IC.DTCONTAGEM
                          AND IT.CDPRODUTO    =   P.CDPRODUTO
                          AND IC.IDSITESTCEGO = 'AP') I
                 WHERE QTINVENTESTCEGO <> QTESTOQDIA";

        $query = $this->connection->prepare($sql);
        $query->execute($params);
        
        return $query->fetchAll();
        
    }

    /**
     * Essa função tem como finalidade retornar todos os parâmetros gerais e de
     * unidade necessários para a validação dos procedimentos envolvidos no
     * fechamento do dia.
     *
     * @param $CDFILIAL | código da unidade em que está sendo fechado o dia
     */
    public function getParameters($CDFILIAL) {
        $sql = "SELECT PE.USR_IDINTEGRASAP,
                       PG.NRORG,
                       PG.IDEXPINFSAP,
                       PG.IDGRAVATITABELA,
                       PE.IDALTDTFECDIA,
                       PF.IDBLOQFECDIA,
                       PF.IDBLOQFECHNF,
                       PF.IDBLFECHSNFE,
                       PF.IDBLOFERTNEV,
                       PF.IDBLOFECHMES,
                       IDBLOQAJUSNEVOL,
                       PF.IDCONSDIAUTFEC,
                       PF.CDLOCALESTOQ,
                       PF.IDINVEROTREQ,
                       PF.CDALMOXARIFE,
                       PF.IDINVROTDIA,
                       PF.NRDIAFECHMES,
                        F.CDFILIAL,
                        F.NMFILIAL,
                       NVL(IDORDIMPLANT,       'P') AS IDORDIMPLANT,
                       NVL(IDORDAJUINVE,       'P') AS IDORDAJUINVE,
                       NVL(PP.IDEFETCARDIA,    'N') AS IDEFETCARDIA,
                       NVL(PV.IDCONSISTECONSO, 'N') AS IDCONSISTECONSO,
                       NVL(PF.IDUTILLOTE,      'N') AS IDUTILLOTE,
                       NVL(PF.IDUTILALMOX,     'N') AS IDUTILALMOX,
                       NVL(PF.IDUTILLCESTQ,    'N') AS IDUTILLCESTQ,
                       SUBSTR(PF.DSPARFILFIS, 4, 1) AS IDBLOQESTNEG,
                       DECODE(PG.IDUTILDTPROC,
                              'S', DECODE(PF.DTPROCESSA,
                                          NULL, TO_CHAR(SYSDATE,       'DD/MM/YYYY'),
                                                TO_CHAR(PF.DTPROCESSA, 'DD/MM/YYYY')),
                                   TO_CHAR(SYSDATE, 'DD/MM/YYYY')) AS DTPROCESSA
                  FROM PARAMGERAL PG
                  JOIN PARAMFILIAL PF
                    ON PF.NRORG      = PG.NRORG
                  JOIN FILIAL F
                    ON F.CDFILIAL    = PF.CDFILIAL
                   AND F.NRORG       = PG.NRORG
                  JOIN PARAMESTOQUE PE
                    ON PE.NRORG      = PG.NRORG
             LEFT JOIN PARAMPLANEJA PP
                    ON PP.CDFILIAL   = PF.CDFILIAL
                   AND PP.NRORG      = PG.NRORG
             LEFT JOIN PARAVEND PV
                    ON PV.CDFILIAL   = PF.CDFILIAL
                   AND PV.NRORG      = PG.NRORG
                 WHERE PG.CDPARGERAL = '0001'
                   AND PE.CDPARESTOQ = '1'
                   AND PF.CDFILIAL   = :CDFILIAL";


        $query = $this->connection->prepare($sql);
        $query->execute(array("CDFILIAL" => $CDFILIAL));

        $result = $query->fetch();

        return $result;
    }

    public function getParperdivestceg($params) {
        $sql = "SELECT VRPERDIVESTCEG
                  FROM PARPERDIVESTCEG
                 WHERE CDFILIAL = :CDFILIAL
                  AND :CDPRODUTO BETWEEN CDPRODUTO AND CDPRODUTO||'zzzzzzzzzz'
              ORDER BY CDPRODUTO DESC";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getSaidasNaoEmitidas($params) {
        $sql = "SELECT N.CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T,
                       MODDOCFISC M
                WHERE (N.CDFILIEMIT    =  :CDFILIAL)
                  AND (N.DTENTRSAID    =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP  =  'S')
                  AND (N.IDSTATUS     <>  'C')
                 AND ((N.IDGEROUTDOCU IS   NULL)
                   OR (N.IDGEROUTDOCU  =  'A'))
                 AND ((N.IDSISTEMA    IN ('DFS','FAI','FAS','FAC'))
                   OR (N.IDSISTEMA    IS   NULL))
                  AND (N.IDENTRSAIDOP  =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER    =   T.CDTIPOOPER)
                  AND (NVL(T.IDCOMPEMISRE, 'F') = 'F')
                  AND (NRSEQCAPADOC   IS   NULL)
                  AND (M.CDMODDOCFISC  =   N.CDMODDOCFISC)
                  AND (M.IDMODDOCNFE  <>  'S')
             UNION ALL
                SELECT N.CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T,
                       MODDOCFISC M
                WHERE (N.CDFILIEMIT    =  :CDFILIAL)
                  AND (N.DTENTRSAID    =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP  =  'S')
                  AND (N.IDSTATUSNFE NOT IN ('C','D','A'))
                 AND ((N.IDGEROUTDOCU IS   NULL)
                   OR (N.IDGEROUTDOCU  =  'A'))
                 AND ((N.IDSISTEMA    IN ('DFS','FAI','FAS','FAC'))
                   OR (N.IDSISTEMA    IS   NULL))
                  AND (N.IDENTRSAIDOP  =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER    =   T.CDTIPOOPER)
                  AND (NVL(T.IDCOMPEMISRE, 'F') = 'F')
                  AND (NRSEQCAPADOC   IS   NULL)
                  AND M.CDMODDOCFISC   =   N.CDMODDOCFISC
                  AND M.IDMODDOCNFE    =  'S'";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function getEntradasNaoEmitidas($params) {
        $sql = "SELECT CDFILIAL, NRLANCTONF
                  FROM NOTAFISCAL NF, MODDOCFISC M, TIPOOPERAC T
                 WHERE T.IDENTRSAIDOP  = NF.IDENTRSAIDOP
                   AND T.CDTIPOOPER    = NF.CDTIPOOPER
                   AND M.CDMODDOCFISC  = NF.CDMODDOCFISC
                   AND NF.CDFILIEMIT   = :P_CDFILIAL
                   AND NF.DTENTRSAID   = :P_DTPROCESSA
                   AND NF.IDENTRSAIDOP = 'S'
                   AND NF.IDSTATUS     = 'P'
                   AND M.IDMODDOCNFE  <> 'S'
                   AND T.IDBLOQFECHADIANF = 'S'
                
                 UNION ALL
                
                SELECT CDFILIAL, NRLANCTONF
                  FROM NOTAFISCAL NF, MODDOCFISC M, TIPOOPERAC T
                 WHERE T.IDENTRSAIDOP  = NF.IDENTRSAIDOP
                   AND T.CDTIPOOPER    = NF.CDTIPOOPER
                   AND M.CDMODDOCFISC  = NF.CDMODDOCFISC
                   AND NF.CDFILIEMIT   = :P_CDFILIAL
                   AND NF.DTENTRSAID   = :P_DTPROCESSA
                   AND NF.IDENTRSAIDOP = 'S'
                   AND NF.IDSTATUSNFE NOT IN ('C','D','A')
                   AND M.IDMODDOCNFE   = 'S'
                   AND T.IDBLOQFECHADIANF = 'S'
                
                UNION ALL
                
                SELECT CDFILIAL, NRLANCTONF
                  FROM NOTAFISCAL NF, TIPOOPERAC T, MODDOCFISC M
                 WHERE NF.CDFILIRECE   = :P_CDFILIAL
                   AND NF.DTENTRSAID   = :P_DTPROCESSA
                   AND NF.IDENTRSAIDOP = 'E'
                   AND NF.IDSTATUS = 'P'
                   AND T.IDENTRSAIDOP = NF.IDENTRSAIDOP
                   AND T.CDTIPOOPER   = NF.CDTIPOOPER
                   AND T.IDUTILEMISNF = 'S'
                   AND M.CDMODDOCFISC = NF.CDMODDOCFISC
                   AND M.IDMODDOCNFE <> 'S'
                
                UNION ALL
                
                SELECT CDFILIAL, NRLANCTONF
                  FROM NOTAFISCAL NF, TIPOOPERAC T, MODDOCFISC M
                 WHERE NF.CDFILIRECE   = :P_CDFILIAL
                   AND NF.DTENTRSAID   = :P_DTPROCESSA
                   AND NF.IDENTRSAIDOP = 'E'
                   AND NOT NF.IDSTATUSNFE IN ('C','D','A')
                   AND T.IDENTRSAIDOP = NF.IDENTRSAIDOP
                   AND T.CDTIPOOPER   = NF.CDTIPOOPER
                   AND T.IDUTILEMISNF = 'S'
                   AND M.CDMODDOCFISC = NF.CDMODDOCFISC
                   AND M.IDMODDOCNFE = 'S'";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function getNFAtrasadas($params) {
        $sql = "SELECT CDFILIAL, NRLANCTONF
                    FROM NOTAFISCAL T
                    WHERE (T.CDFILIRECE = :P_CDFILIAL) AND
                          (T.IDENTRSAIDOP = 'E') AND
                          (T.CDTIPOOPER   = '10') AND
                          (T.DTENTRSAID = :P_DTPROCESSA)
                    MINUS
                    SELECT IT.CDFILIALIT, IT.NRLANCTONFIT
                      FROM ITEMNOTAFISC IT, NOTAFISCAL T
                      WHERE (T.CDFILIRECE   = :P_CDFILIAL) AND
                            (T.IDENTRSAIDOP = 'E')         AND
                            (T.CDTIPOOPER   = '11')        AND
                            (T.DTENTRSAID = :P_DTPROCESSA) AND
                            (T.CDFILIAL   = IT.CDFILIAL)   AND
                            (T.NRLANCTONF = IT.NRLANCTONF)";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    /**
     * Essa função tem como finalidade retornar todas as vendas não consolidadas
     * de uma unidade para uma certa data.
     *
     * @param $params | array associativo que deve conter os seguintes parâmetros:
     *                | CDFILIAL   | código da unidade em que está sendo fechado o
     *                               dia
     *                | DTPROCESSA | data de processamento daquela unidade
     */
    public function getVendasNaoConsolidadas($params) {
        $sql = "SELECT V.NRSEQVENDA
                  FROM VENDA V,
                       ITEMVENDA I
                 WHERE V.CDFILIAL    = :CDFILIAL
                   AND V.DTENTRVENDA = :DTPROCESSA
                   AND V.CDFILIAL    =  I.CDFILIAL
                   AND V.CDCAIXA     =  I.CDCAIXA
                   AND V.NRSEQVENDA  =  I.NRSEQVENDA
                   AND V.IDSITUVENDA = 'O'
                   AND I.NRLANCTONF IS NULL
                   AND I.NRLANCESTQ IS NULL";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function updateIteminventcego($params) {
        $sql = "UPDATE ITEMINVENTCEGO
                   SET QTPOSESTINVCEGO = :QTPOSESTINVCEGO
                 WHERE CDFILIAL        = :CDFILIAL
                   AND DTCONTAGEM      = :DTCONTAGEM
                   AND CDALMOXARIFE    = :CDALMOXARIFE
                   AND CDLOCALESTOQ    = :CDLOCALESTOQ
                   AND NRLOTEESTQ      = :NRLOTEESTQ
                   AND NRSUBLOTE       = :NRSUBLOTE
                   AND CDPRODUTO       = :CDPRODUTO";

        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }

    public function callProcedureExportaTabelaTi($CDFILIAL, $DTFINAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_TABELA_TI');

        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $DTFINAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }

    public function callProcedureExportaTiSap($DATAINI, $DATAFINAL, $FILIAL, $TCDFILIAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_TI_SAP');

        $procedure->addParam(new Param('P_FILIAL', Param::PARAM_INPUT, $FILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $DATAINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAFINAL', Param::PARAM_INPUT, $DATAFINAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $TCDFILIAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }

    public function callProcedureExportaTransfEstoqueTm($CDFILIAL, $CDOPERADOR, $DTINICIAL, $DTFINAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_TRANSF_ESTOQUE_TM');

        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $CDOPERADOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $DTINICIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $DTFINAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }
    
    public function callProcedureCchExportaProduto() {
        $procedure = new StoredProcedure($this->connection, 'CCH_EXPORTA_PRODUTO_SAP');

        $output = $procedure->execute();
    }
    
     public function callProcedureCchNfEntrada($CDFILIAL, $CDOPERADOR, $DTINICIAL, $DTFINAL) {
        $procedure = new StoredProcedure($this->connection, 'CCH_EXPORTA_NF_ENTRADA_SAP ');

        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $CDOPERADOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $DTINICIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $DTFINAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }
    
     public function callProcedureCchNfSaida($CDFILIAL, $CDOPERADOR, $DTINICIAL, $DTFINAL) {
        $procedure = new StoredProcedure($this->connection, 'CCH_EXPORTA_NF_SAIDA_SAP ');

        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $CDOPERADOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $DTINICIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $DTFINAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }
    
     public function callProcedureCchExportaTi($CDFILIAL, $CDOPERADOR, $DTINICIAL, $DTFINAL) {
        $procedure = new StoredProcedure($this->connection, 'CCH_EXPORTA_TI_SAP ');

        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $CDOPERADOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $DTINICIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $DTFINAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }

    public function callProcedureExportaTmSap($FILIAL, $DATAINI, $DATAFINAL, $TCDFILIAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_TM_SAP');

        $procedure->addParam(new Param('P_FILIAL', Param::PARAM_INPUT, $FILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $DATAINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAFINAL', Param::PARAM_INPUT, $DATAFINAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $TCDFILIAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }
    
    public function callProcedureExportaNFEntradaSAP($DATAINI, $DATAFINAL, $FILIAL, $TCDFILIAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_NF_ENTRADA_SAP');

        $procedure->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $DATAINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAFINAL', Param::PARAM_INPUT, $DATAFINAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $FILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $TCDFILIAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }

    public function callProcedureExportaNFSaidaSAP($DATAINI, $DATAFINAL, $FILIAL, $TCDFILIAL) {
        $procedure = new StoredProcedure($this->connection, 'EXPORTA_NF_SAIDA_SAP');

        $procedure->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $DATAINI, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAFINAL', Param::PARAM_INPUT, $DATAFINAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $FILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TCDFILIAL', Param::PARAM_INPUT, $TCDFILIAL, Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }
    
    public function callProcedureValidaCardapioFecdia($CDFILIAL, $DTPROCESSA) {
        $procedure = new StoredProcedure($this->connection, 'VALIDA_CARDAPIO_FECDIA');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAPROC', Param::PARAM_INPUT, $DTPROCESSA, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVDIFEFET', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 50));
        $procedure->addParam(new Param('P_SEMEFETIVOS', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 50));
        $procedure->addParam(new Param('P_SEMRETIRADA', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 50));
        $procedure->addParam(new Param('P_NAOEVOLESTOQ', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 50));
        $procedure->addParam(new Param('P_SERVSEMRETI', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 50));
        $output = $procedure->execute();
        return $output;
    }

    public function getDtfecmes($params) {
        $sql = "SELECT DTFECMES
                  FROM DIAFECMES
                 WHERE CDFILIAL = :CDFILIAL
                   AND NRORG    = :NRORG
                   AND DTFECMES BETWEEN :DTINICIAL AND :DTFINAL";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        $result = $query->fetch();
        
        //verifica de $result é array e se ele tem DTFECMES
        if (is_array($result) && array_key_exists('DTFECMES', $result)) {
            return $result['DTFECMES'];
        } else {
            return false;
        }

    }

    public function getDtferifili($params) {
        $sql = "SELECT TO_DATE(TO_CHAR(DTFERIFILI, 'DD/MM/YYYY'), 'DD/MM/YYYY') AS DTFERIFILI
                  FROM FERIFILI
                 WHERE CDFILIAL = :CDFILIAL
                   AND DTFERIFILI BETWEEN :DTINICIAL AND :DTFINAL
              ORDER BY DTFERIFILI";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getNfsEmitidas($params) {
        $sql = "SELECT N.CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T,
                       MODDOCFISC M
                WHERE (N.NRORG                  =  :NRORG)
                  AND (N.CDFILIEMIT             =  :CDFILIAL)
                  AND (N.DTENTRSAID             =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP           =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER             =   T.CDTIPOOPER)
                  AND (N.NRORG                  =   T.NRORG)
                  AND (M.CDMODDOCFISC           =   N.CDMODDOCFISC)
                  AND (M.NRORG                  =   N.NRORG)
                  AND (N.IDENTRSAIDOP           =  'S')
                  AND (N.IDSTATUS              <>  'C')
                  AND (NVL(T.IDCOMPEMISRE, 'F') =  'F')
                  AND (M.IDMODDOCNFE           <>  'S')
                 AND ((N.IDGEROUTDOCU           =  'A')
                   OR (N.IDGEROUTDOCU          IS   NULL))
                 AND ((N.IDSISTEMA             IN ('DFS', 'FAI', 'FAS', 'FAC'))
                   OR (N.IDSISTEMA             IS   NULL))
                  AND (NRSEQCAPADOC            IS   NULL)
             UNION ALL
                SELECT N.CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T,
                       MODDOCFISC M
                WHERE (N.NRORG                  =  :NRORG)
                  AND (N.CDFILIEMIT             =  :CDFILIAL)
                  AND (N.DTENTRSAID             =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP           =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER             =   T.CDTIPOOPER)
                  AND (N.NRORG                  =   T.NRORG)
                  AND (M.CDMODDOCFISC           =   N.CDMODDOCFISC)
                  AND (M.NRORG                  =   N.NRORG)
                  AND (N.IDENTRSAIDOP           =  'S')
                  AND (NVL(T.IDCOMPEMISRE, 'F') =  'F')
                  AND (M.IDMODDOCNFE            =  'S')
                 AND ((N.IDGEROUTDOCU           =  'A')
                   OR (N.IDGEROUTDOCU          IS   NULL))
                 AND ((N.IDSISTEMA             IN ('DFS', 'FAI', 'FAS', 'FAC'))
                   OR (N.IDSISTEMA             IS   NULL))
                  AND (N.IDSTATUSNFE NOT       IN ('C'))
                  AND (NRSEQCAPADOC            IS   NULL)";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getParamsGr($params) {
        $sql = "SELECT E.CDRELATEXP,
                       E.NMARQTXTEXP,
                       E.DSDIRARQEXP,
                       E.NRDIAARQEXP,
                       P.IDGTGTXTFDIA,
                       E.IDEXPORDADOSTAB
                  FROM EXPAUTFILIAL E,
                       PARAMESTOQUE P
                 WHERE E.CDFILIAL = :CDFILIAL
                   AND E.NRORG    = :NRORG
                   AND P.NRORG    =  E.NRORG
              ORDER BY E.CDRELATEXP";

        $query = $this->connection->prepare($sql);
        $query->execute($params);
        
        $resultado = $query->fetchAll();

        foreach($resultado as $param) {
            if(strtoupper($param["CDRELATEXP"]) == "ADM01317" || strtoupper($param["CDRELATEXP"]) == "ADM01325") {

                return $param;
            }
        }
        if(!empty($resultado)) {
            return $resultado[0];
        }
        else {
            return array("CDRELATEXP" => "");
        }
    }

    public function getReEntr($params) {
        $sql = "SELECT CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T
                WHERE (N.NRORG                  =  :NRORG)
                  AND (N.CDFILIRECE             =  :CDFILIAL)
                  AND (N.DTENTRSAID             =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP           =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER             =   T.CDTIPOOPER)
                  AND (N.NRORG                  =   T.NRORG)
                  AND (N.IDENTRSAIDOP           =  'E')
                  AND (N.IDSTATUS              <>  'C')
                  AND (NVL(T.IDCOMPEMISRE, 'F') =  'F')
                 AND ((N.IDSISTEMA             IN ('DFE', 'EST'))
                   OR (N.IDSISTEMA             IS   NULL))
                  AND (N.CDTIPOOPER NOT        IN ('09', '10'))
                  AND (NRSEQCAPADOC            IS   NULL)";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getReSaid($params) {
        $sql = "SELECT N.CDFILIAL
                  FROM NOTAFISCAL N,
                       TIPOOPERAC T,
                       MODDOCFISC M
                WHERE (N.NRORG                  =  :NRORG)
                  AND (N.CDFILIEMIT             =  :CDFILIAL)
                  AND (N.DTENTRSAID             =  :DTENTRSAID)
                  AND (N.IDENTRSAIDOP           =   T.IDENTRSAIDOP)
                  AND (N.CDTIPOOPER             =   T.CDTIPOOPER)
                  AND (N.NRORG                  =   T.NRORG)
                  AND (M.CDMODDOCFISC           =   N.CDMODDOCFISC)
                  AND (M.NRORG                  =   N.NRORG)
                  AND (N.IDENTRSAIDOP           =  'S')
                  AND (N.IDSTATUS              <>  'C')
                  AND (M.IDMODDOCNFE           <>  'S')
                  AND (NVL(T.IDCOMPEMISRE, 'F') =  'F')
                 AND ((N.IDGEROUTDOCU           =  'A')
                   OR (N.IDGEROUTDOCU          IS   NULL))
                 AND ((N.IDSISTEMA             IN ('DFS','FAI','FAS','FAC'))
                   OR (N.IDSISTEMA             IS   NULL))
                  AND (NRSEQCAPADOC            IS   NULL)
            UNION ALL
               SELECT N.CDFILIAL
                 FROM NOTAFISCAL N,
                      TIPOOPERAC T,
                      MODDOCFISC M
               WHERE (N.NRORG                  =  :NRORG)
                 AND (N.CDFILIEMIT             =  :CDFILIAL)
                 AND (N.DTENTRSAID             =  :DTENTRSAID)
                 AND (N.IDENTRSAIDOP           =   T.IDENTRSAIDOP)
                 AND (N.CDTIPOOPER             =   T.CDTIPOOPER)
                 AND (N.NRORG                  =   T.NRORG)
                 AND (M.CDMODDOCFISC           =   N.CDMODDOCFISC)
                 AND (M.NRORG                  =   N.NRORG)
                 AND (N.IDENTRSAIDOP           =  'S')
                 AND (NVL(T.IDCOMPEMISRE, 'F') =  'F')
                 AND (M.IDMODDOCNFE            =  'S')
                 AND (N.IDSTATUSNFE NOT       IN ('C'))
                AND ((N.IDGEROUTDOCU           =  'A')
                  OR (N.IDGEROUTDOCU          IS   NULL))
                AND ((N.IDSISTEMA             IN ('DFS','FAI','FAS','FAC'))
                  OR (N.IDSISTEMA             IS   NULL))
                 AND (NRSEQCAPADOC            IS   NULL)";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }

    public function getReSaidaEntr($params) {
        $sql = "SELECT P.CDFILIAL,
                       IDINVROTFMES,
                       VRPERCINVROT,
                       IDCONSREFECH,
                       IDINVROTDIA,
                       DTPROCESSA,
                       IDBLOFECHMES,
                       IDBLOQAJUSNEVOL,
                       IDUTILALMOX,
                       IDUTILLCESTQ,
                       NRDIAFECHMES,
                       IDBLOQFECHNF,
                       IDUTILLOTE,
                       IDBLOFERTNEV,
                       IDBLFECHSNFE,
                       IDINVROTEST,
                       IDBLOQFECDIA,
                       IDINVEROTREQ,
                       CDFILCENTPME,
                       CDALMOXARIFE,
                       CDLOCALESTOQ,
                       NVL(IDCONSDIAUTFEC,'S') AS IDCONSDIAUTFEC,
                       NVL(IDFDIAENTREST,'N')  AS IDFDIAENTREST,
                       NVL(IDFDIASAIDEST,'N')  AS IDFDIASAIDEST,
                       NVL(IDFDIACARDAP,'N')   AS IDFDIACARDAP,
                       NVL(IDFDIARETIEST,'N')  AS IDFDIARETIEST,
                       NVL(IDFDIAREQEST,'N')   AS IDFDIAREQEST,
                       NVL(IDFDIAREQPLA,'N')   AS IDFDIAREQPLA,
                       NVL(IDFDIAEFEPLA,'N')   AS IDFDIAEFEPLA,
                       NVL(IDFDIAEFEFAT,'N')   AS IDFDIAEFEFAT,
                       SUBSTR(DSPARFILFIS,4,1) AS IDBLOQESTNEG,
                       NVL(IDCONSRMCFDIA,'N')  AS IDCONSRMCFDIA,
                       NVL(CDTIPCUSTEST,3)     AS CDTIPCUSTEST,
                       IDINVESTCEGO,
                       IDCTRLESTQ,
                       IDBLOQEFEPDIFEFEF
                  FROM PARAMFILIAL P,
                       FILIAL F
                WHERE (P.CDFILIAL = :CDFILIAL)
                  AND (P.NRORG    = :NRORG)
                  AND (P.CDFILIAL =  F.CDFILIAL)
                  AND (P.NRORG    =  F.NRORG)";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }

    public function getInventErrorCodesWithAllotment($params) {
        $sql = "SELECT CDALMOXARIFE,
                       CDLOCALESTOQ
                  FROM INVEROTALOTE
                WHERE (CDFILIAL = :CDFILIAL)
                  AND (DTINVELOTE = (SELECT MAX(DTINVELOTE)
                                       FROM INVEROTALOTE
                                     WHERE (CDFILIAL = :CDFILIAL)
                                       AND (DTINVELOTE < :DTINVEROTA)))
                  AND (IDINVLOTEOK = 'N')";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }

    public function getInventErrorCodesWithoutAllotment($params) {
        $sql = "SELECT CDALMOXARIFE,
                       CDLOCALESTOQ
                  FROM INVEROTA
                WHERE (CDFILIAL = :CDFILIAL)
                  AND (DTINVEROTA = (SELECT MAX(DTINVEROTA)
                                       FROM INVEROTA
                                     WHERE (CDFILIAL = :CDFILIAL)
                                       AND (DTINVEROTA < :DTINVEROTA)))
                  AND (IDINVENTOK = 'N')";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }
    
    public function getDadosFilial($CDFILIAL) {
        $sql = "SELECT PG.NRORG,
                  F.CDFILIAL,
                  F.NMFILIAL,
                  DECODE(PG.IDUTILDTPROC,'S',DECODE(PF.DTPROCESSA, NULL, TO_CHAR(SYSDATE,'DD/MM/YYYY'),TO_CHAR(PF.DTPROCESSA,'DD/MM/YYYY')),TO_CHAR(SYSDATE,'DD/MM/YYYY')) AS DTPROCESSA,
                  PE.IDALTDTFECDIA ,
                  PF.IDCONSDIAUTFEC
                FROM PARAMGERAL PG,
                  PARAMESTOQUE PE,
                  PARAMFILIAL PF,
                  FILIAL F
                WHERE PG.CDPARGERAL = '0001'
                AND PE.CDPARESTOQ   = '1'
                AND PF.CDFILIAL     = :CDFILIAL
                AND F.CDFILIAL      = PF.CDFILIAL
                AND PE.NRORG        = PG.NRORG
                AND PF.NRORG        = PG.NRORG
                AND F.NRORG         = PG.NRORG";
                
        $params = array("CDFILIAL" => $CDFILIAL);
                
        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
        
    }
    
    public function getServiceName($CDFILIAL,$CDSERVFILI) {
        $sql = "SELECT SE.CDSERVFILI, SE.NMSERVICO
                  FROM SERVICO SE
                 WHERE (SE.CDFILIAL = :CDFILIAL ) 
                   AND (SE.CDSERVFILI = :CDSERVFILI)
                 ORDER BY SE.CDSERVFILI";
                
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "CDSERVFILI"=> $CDSERVFILI
        );
                
        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
        
    }
    
    public function validaImplatacaoAjusteDesatualizado($CDFILIAL,$DTPROCESSA){
        $sql = "SELECT DISTINCT CDFILIAL FROM ITLANCTOEST
                 WHERE CDFILIAL = :CDFILIAL
                   AND IDTIPOMOVI IN ('0','1')
                   AND DTLANCMOVI = :DTLANCMOVI
                   AND IDEVOLESTOQ = 'N'";
                
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "DTLANCMOVI" => $DTPROCESSA
        );
                
        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }
    
}
