package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class LoginPage extends PageBase {
    //Mapping   
    By usernameField = By.xpath("//*[@zh-post-repeat='templateManager.container.refresh()']//*[@id='USER']");
    By passwordField = By.xpath("//*[@class='row']//*[@id='PASSWORD']");
    By loginButton = By.xpath("//*[@id='SUBMIT']");
    By mensagemErroTextArea = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-alert-scroll']");
    By mensagemAlert = By.xpath("//*[@class='zh-footer-alert']//*[@class='zh-alert-button horizontal']//*[.='Sim']");
    By mensagemAlert2 = By.xpath("//*[@class='zh-alert-button']");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By loadingWait2 = By.xpath("//div[@class='zh-position-loading']");

    //Parametros de Login:


    public void preenhcerUsuario(String usuario){
        waitForInvisibilityOfElementLocated(loadingWait2);
        sendKeys(usernameField, usuario);
    }


    public void preencherSenha(String senha){
        waitForInvisibilityOfElementLocated(loadingWait2);
        waitForVisibilityOfElementLocated(passwordField);
        sendKeys(passwordField, senha);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void clicarEmLogin(){
        waitForVisibilityOfElementLocated(loginButton);
        click(loginButton);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public boolean aceitarMensagemAlerta(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(mensagemErroTextArea);
        waitForVisibilityOfElementLocated(mensagemAlert);
        click(mensagemAlert);
        waitForInvisibilityOfElementLocated(loadingWait);
        return false;
    }
    public void aceitarMensagemAlerta2(){
        click(mensagemAlert2);
    }
    public String retornaMensagemDeErro(){
        return getText(mensagemErroTextArea);
    }

}
